ShockolateFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0");
ShockolateFu.name = "Shockolate";

ShockolateFu.defaultPosition = "LEFT";
ShockolateFu.cannotDetachTooltip = true;
ShockolateFu.canHideText = true;

ShockolateFu.hasIcon = "Interface\\Icons\\Spell_Nature_GroundingTotem";

local Tablet = AceLibrary("Tablet-2.0");
local Dewdrop = AceLibrary("Dewdrop-2.0");

function ShockolateFu:OnTextUpdate()
        ShockolateFu:SetText("Shockolate");
end;

function ShockolateFu:OnMenuRequest(level, value)
        if (level == 1) then
                Dewdrop:AddLine(
                        'text', "Change Setup",
                        'isTitle', true
                )
                for i=1,getn(TotemOptions["SetupList"]) do
                        if (TotemOptions["CurrentSetup"] == TotemOptions["SetupList"][i]) then
                                Dewdrop:AddLine(
                                        'text', TotemOptions["SetupList"][i],
                                        'isRadio', true,
                                        'checked', true
                                )
                        else
                                Dewdrop:AddLine(
                                        'text', TotemOptions["SetupList"][i],
                                        'isRadio', true,
                                        'func', function() Shockolate.ChangeSetup(i) end
                                )
                        end;
                end;
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "New Setup",
                        'hasArrow', true,
                        'hasEditBox', true,
                        'editBoxFunc', function(text) Shockolate.SaveNewSetup(text); end
                )
                Dewdrop:AddLine(
                        'text', "Delete Setup",
                        'hasArrow', true,
                        'value', 6
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Ring Options",
                        'isTitle', true
                )
                Dewdrop:AddLine(
                        'text', TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["ShowName"],
                        'hasArrow', true,
                        'value', 1
                )
                Dewdrop:AddLine(
                        'text', TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["ShowName"],
                        'hasArrow', true,
                        'value', 2
                )
                Dewdrop:AddLine(
                        'text', TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["ShowName"],
                        'hasArrow', true,
                        'value', 3
                )
                Dewdrop:AddLine(
                        'text', TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["ShowName"],
                        'hasArrow', true,
                        'value', 4
                )
                Dewdrop:AddLine(
                        'text', TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["ShowName"],
                        'hasArrow', true,
                        'value', 5
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Countdown Color",
                        'hasColorSwatch', true,
                        'hasOpacity', false,
                        'colorFunc', function(r,g,b) Shockolate.SetTextColor(r,g,b) end
                )
                Dewdrop:AddLine()
        elseif (level == 2) then
                if (value == 6) then
                        for i=1,getn(TotemOptions["SetupList"]) do
                                if (TotemOptions["SetupList"][i] ~= "Default") then
                                        Dewdrop:AddLine(
                                                'text', TotemOptions["SetupList"][i],
                                                'func', function() Shockolate.DeleteSetup(TotemOptions["SetupList"][i]) end
                                        )
                                end;
                        end;
                        return;
                end;
                if (value == 1) then
                        SC_menuRingType = "Earth";
                elseif (value == 2) then
                        SC_menuRingType = "Fire";
                elseif (value == 3) then
                        SC_menuRingType = "Water";
                elseif (value == 4) then
                        SC_menuRingType = "Air";
                elseif (value == 5) then
                        SC_menuRingType = "Utility";
                else
                        SC_menuRingType = "";
                end;
                if (TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["Shown"] == 0) then
                        Dewdrop:AddLine(
                                'text', "Show Ring",
                                'checked', false,
                                'func', function() Shockolate.ShowToggle(SC_menuRingType, 1) end
                        )
                else
                        Dewdrop:AddLine(
                                'text', "Show Ring",
                                'checked', true,
                                'func', function() Shockolate.ShowToggle(SC_menuRingType, 0) end
                        )
                end;
                Dewdrop:AddLine(
                        'text', "Opacity (OC)",
                        'hasArrow', true,
                        'hasSlider', true,
                        'sliderMin', 0,
                        'sliderMax', 1,
                        'sliderStep', 0.1,
                        'sliderIsPercent', true,
                        'sliderValue', TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["Alpha"],
                        'sliderFunc', function(value) TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["Alpha"] = value; Shockolate.SetRingAlpha(SC_menuRingType, value) end
                )
                Dewdrop:AddLine(
                        'text', "Opacity (IC)",
                        'hasArrow', true,
                        'hasSlider', true,
                        'sliderMin', 0,
                        'sliderMax', 1,
                        'sliderStep', 0.1,
                        'sliderIsPercent', true,
                        'sliderValue', TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["CombatAlpha"],
                        'sliderFunc', function(value) TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["CombatAlpha"] = value; end
                )
                Dewdrop:AddLine(
                        'text', "Ring Scale",
                        'hasArrow', true,
                        'hasSlider', true,
                        'sliderMin', 0.5,
                        'sliderMax', 2.5,
                        'sliderStep', 0.1,
                        'sliderIsPercent', true,
                        'sliderValue', TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["Scale"],
                        'sliderFunc', function(value) Shockolate.SetRingScale(SC_menuRingType, value); end
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Display Name",
                        'hasArrow', true,
                        'hasEditBox', true,
                        'editBoxText', TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"]["ShowName"],
                        'editBoxFunc', function(text) Shockolate.ChangeRingName(SC_menuRingType, text); end
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Button Positions",
                        'hasArrow', true,
                        'value', value
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Show/Hide Buttons",
                        'hasArrow', true,
                        'value', value+5
                )
                Dewdrop:AddLine()
                Dewdrop:AddLine(
                        'text', "Reset Position",
                        'func', function() Shockolate.ResetRingPosition(SC_menuRingType); end
                )
        elseif (level == 3) then
                if (value == 1) or (value == 6) then
                        SC_menuRingType = "Earth";
                elseif (value == 2) or (value == 7) then
                        SC_menuRingType = "Fire";
                elseif (value == 3) or (value == 8) then
                        SC_menuRingType = "Water";
                elseif (value == 4) or (value == 9) then
                        SC_menuRingType = "Air";
                elseif (value == 5) or (value == 10) then
                        SC_menuRingType = "Utility";
                else
                        SC_menuRingType = "";
                end;
                if (value < 6) then
                        Dewdrop:AddLine(
                                'text', SC_menuRingType,
                                'isTitle', true
                        )
                        for i=1,8 do
                                Dewdrop:AddLine(
                                        'text', "Button "..i,
                                        'hasArrow', true,
                                        'hasSlider', true,
                                        'sliderMin', 0,
                                        'sliderMax', 360,
                                        'sliderStep', 5,
                                        'sliderValue', TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"][tostring(i)]["Position"],
                                        'sliderFunc', function(value) Shockolate.SetSinglePosition(i, SC_menuRingType, value); end
                                )
                        end;
                elseif (value < 11) then
                        Dewdrop:AddLine(
                                'text', SC_menuRingType,
                                'isTitle', true
                        )
                        for i=1,8 do
                                if (TotemOptions[TotemOptions["CurrentSetup"]][SC_menuRingType.."Ring"][tostring(i)]["Shown"] == 0) then
                                        Dewdrop:AddLine(
                                                'text', "Button "..i,
                                                'checked', false,
                                                'func', function() Shockolate.ShowIndivToggle(i, SC_menuRingType, 1) end
                                        )
                                else
                                        Dewdrop:AddLine(
                                                'text', "Button "..i,
                                                'checked', true,
                                                'func', function() Shockolate.ShowIndivToggle(i, SC_menuRingType, 0) end
                                        )
                                end;
                        end;
                end;
        end;
end;

function ShockolateFu:OnTooltipUpdate()
        local shocktip = Tablet:AddCategory(
                'columns', 2,
                'child_textR', 0,
                'child_textG', 1,
                'child_textB', 0,
                'child_textR2', 0,
                'child_textG2', 1,
                'child_textB2', 0
        );
        shocktip:AddLine(
                'text', "Setup: ",
                'text2', TotemOptions["CurrentSetup"]
        );
        local shocktip = Tablet:AddCategory(
                'text', "Totem Cooldowns",
                'columns', 2,
                'textR', 0,
                'textG', 1,
                'textB', 0,
                'child_textR', 0.75,
                'child_textG', 0.75,
                'child_textB', 0.75,
                'child_textR2', 1,
                'child_textG2', 1,
                'child_textB2', 1
        );
        if TotemDuration["Earth"] then
                shocktip:AddLine(
                        'text', "Earth Totem",
                        'text2', ceil(TotemDuration["Earth"]).."sec"
                );
        end;
        if TotemDuration["Fire"] then
                shocktip:AddLine(
                        'text', "Fire Totem",
                        'text2', ceil(TotemDuration["Fire"]).."sec"
                );
        end;
        if TotemDuration["Water"] then
                shocktip:AddLine(
                        'text', "Water Totem",
                        'text2', ceil(TotemDuration["Water"]).."sec"
                );
        end;
        if TotemDuration["Air"] then
                shocktip:AddLine(
                        'text', "Air Totem",
                        'text2', ceil(TotemDuration["Air"]).."sec"
                );
        end;
        if TotemDuration["Utility"] then
                shocktip:AddLine(
                        'text', "Reincarnation Cooldown",
                        'text2', ceil(TotemDuration["Utility"]).."sec"
                );
        end;

        local shocktip = Tablet:AddCategory(
                'text', "Reagents",
                'columns', 2,
                'textR', 0,
                'textG', 1,
                'textB', 0,
                'child_textR', 0.75,
                'child_textG', 0.75,
                'child_textB', 0.75,
                'child_textR2', 1,
                'child_textG2', 1,
                'child_textB2', 1
        );
        shocktip:AddLine(
                'text', "Ankh",
                'text2', GetItemCount(17030)
        );
        shocktip:AddLine(
                'text', "Shiny Fish Scale",
                'text2', GetItemCount(17057)
        );
        shocktip:AddLine(
                'text', "Fish Oil",
                'text2', GetItemCount(17058)
        );

        Tablet:SetHint("Click to display the UI");
end;

function ShockolateFu:OnClick()
        if Shockolate_OptionsUI:IsVisible() then
                HideUIPanel(Shockolate_OptionsUI);
        else
                ShowUIPanel(Shockolate_OptionsUI);
        end;
end;

Shockolate = {

OnLoad = function()
        TotemDuration = {
                ["Earth"] = nil;
                ["Fire"] = nil;
                ["Water"] = nil;
                ["Air"] = nil;
                ["Utility"] = nil;
        }

        if (UnitClass("player") ~= "Shaman") then
                Shockolate_MainFrame:UnregisterEvent("VARIABLES_LOADED");
                Shockolate_MainFrame:UnregisterEvent("PLAYER_LOGIN");
                Shockolate_MainFrame:UnregisterEvent("UNIT_SPELLCAST_SENT");
                Shockolate_MainFrame:UnregisterEvent("CHAT_MSG_ADDON");
                Shockolate_MainFrame:UnregisterEvent("PLAYER_ALIVE");
                Shockolate_MainFrame:UnregisterEvent("PLAYER_REGEN_ENABLED");
                Shockolate_MainFrame:UnregisterEvent("PLAYER_REGEN_DISABLED");
                return;
        end;
        SlashCmdList["SHOCKOLATE"] = Shockolate.SlashCommand;
        SLASH_SHOCKOLATE1 = "/totem";
        SLASH_SHOCKOLATE2 = "/sc";
        SLASH_SHOCKOLATE3 = "/shockolate";

        UIPanelWindows["Shockolate_OptionsUI"] = { area = "left", pushable = 1 };

        Shockolate.Print("echo", "Shockolate v0.03 Loaded");

        if not TotemOptions then
                TotemOptions = { };
        end;
        if ((TotemOptions["Version"] == nil) or (TotemOptions["Version"] < 0.02)) then
                Shockolate.Print("echo", "Shockolate Settings Reset! Major Version Change!");
                TotemOptions = { };
        end;
        TotemOptions["Version"] = 0.03;
        if not TotemOptions["CurrentSetup"] then
                TotemOptions["CurrentSetup"] = "Default";
        end;
        if not TotemOptions["SetupList"] then
                TotemOptions["SetupList"] = {
                        "Default",
                }
        end;
        if not TotemOptions["Default"] then
                TotemOptions["Default"] = { };
        end;
        if not TotemOptions["Default"]["TextOptions"] then
                TotemOptions["Default"]["TextOptions"] = {
                        ["r"] = 1,
                        ["g"] = 1,
                        ["b"] = 1,
                }
        end;
        if not TotemOptions["Default"]["EarthRing"] then
                TotemOptions["Default"]["EarthRing"] = {
                        ["Shown"] = true,
                        ["Scale"] = 1.5,
                        ["SmallScale"] = 0.55,
                        ["Radius"] = 50,
                        ["Alpha"] = 1,
                        ["CombatAlpha"] = 1,
                        ["ShowName"] = "Earth Ring";
                        ["Main"] = {
                                ["Spell"] = "Strength of Earth Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_EarthBindTotem",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                        ["Second"] = {
                                ["Spell"] = "Earthbind Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_StrengthOfEarthTotem02",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                }
                for i=1,8 do
                        TotemOptions["Default"]["EarthRing"][tostring(i)] = {
                                ["Shown"] = true,
                                ["Spell"] = "",
                                ["Icon"] = "",
                                ["Position"] = 360/8*i,
                                ["Type"] = "spell",
                        }
                end;
        end;
        if not TotemOptions["Default"]["FireRing"] then
                TotemOptions["Default"]["FireRing"] = {
                        ["Shown"] = true,
                        ["Scale"] = 1.5,
                        ["SmallScale"] = 0.55,
                        ["Radius"] = 50,
                        ["Alpha"] = 1,
                        ["CombatAlpha"] = 1,
                        ["ShowName"] = "Fire Ring";
                        ["Main"] = {
                                ["Spell"] = "Searing Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Fire_SearingTotem",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                        ["Second"] = {
                                ["Spell"] = "Magma Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_GuardianWard",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                }
                for i=1,8 do
                        TotemOptions["Default"]["FireRing"][tostring(i)] = {
                                ["Shown"] = true,
                                ["Spell"] = "",
                                ["Icon"] = "",
                                ["Position"] = 360/8*i,
                                ["Type"] = "spell",
                        }
                end;
        end;
        if not TotemOptions["Default"]["WaterRing"] then
                TotemOptions["Default"]["WaterRing"] = {
                        ["Shown"] = true,
                        ["Scale"] = 1.5,
                        ["SmallScale"] = 0.55,
                        ["Radius"] = 50,
                        ["Alpha"] = 1,
                        ["CombatAlpha"] = 1,
                        ["ShowName"] = "Water Ring";
                        ["Main"] = {
                                ["Spell"] = "Mana Spring Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_ManaRegenTotem",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                        ["Second"] = {
                                ["Spell"] = "Poison Cleansing Totem",
                                ["Icon"] = "Interface\\Icons\\INV_Spear_04",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                }
                for i=1,8 do
                        TotemOptions["Default"]["WaterRing"][tostring(i)] = {
                                ["Shown"] = true,
                                ["Spell"] = "",
                                ["Icon"] = "",
                                ["Position"] = 360/8*i,
                                ["Type"] = "spell",
                        }
                end;
        end;
        if not TotemOptions["Default"]["AirRing"] then
                TotemOptions["Default"]["AirRing"] = {
                        ["Shown"] = true,
                        ["Scale"] = 1.5,
                        ["SmallScale"] = 0.55,
                        ["Radius"] = 50,
                        ["Alpha"] = 1,
                        ["CombatAlpha"] = 1,
                        ["ShowName"] = "Air Ring";
                        ["Main"] = {
                                ["Spell"] = "Grounding Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_GroundingTotem",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                        ["Second"] = {
                                ["Spell"] = "Grace of Air Totem",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_NatureResistanceTotem",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                }
                for i=1,8 do
                        TotemOptions["Default"]["AirRing"][tostring(i)] = {
                                ["Shown"] = true,
                                ["Spell"] = "",
                                ["Icon"] = "",
                                ["Position"] = 360/8*i,
                                ["Type"] = "spell",
                        }
                end;
        end;
        if not TotemOptions["Default"]["UtilityRing"] then
                TotemOptions["Default"]["UtilityRing"] = {
                        ["Shown"] = true,
                        ["Scale"] = 1.5,
                        ["SmallScale"] = 0.55,
                        ["Radius"] = 50,
                        ["Alpha"] = 1,
                        ["CombatAlpha"] = 1,
                        ["ShowName"] = "Utility Ring";
                        ["Main"] = {
                                ["Spell"] = "Windfury Weapon",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_Cyclone",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                        ["Second"] = {
                                ["Spell"] = "Rockbiter Weapon",
                                ["Icon"] = "Interface\\Icons\\Spell_Nature_RockBiter",
                                ["Keybind"] = nil,
                                ["Type"] = "spell",
                        },
                }
                for i=1,8 do
                        TotemOptions["Default"]["UtilityRing"][tostring(i)] = {
                                ["Shown"] = true,
                                ["Spell"] = "",
                                ["Icon"] = "",
                                ["Position"] = 360/8*i,
                                ["Type"] = "spell",
                        }
                end;
        end;

        TotemTimes = {
                ["Earthbind Totem"] = 45,
                ["Strength of Earth Totem"] = 120,
                ["Stoneskin Totem"] = 120,
                ["Stoneclaw Totem"] = 15,
                ["Tremor Totem"] = 120,
                ["Earth Elemental Totem"] = 120,

                ["Searing Totem"] = {
                        ["Rank 1"] = 30,
                        ["Rank 2"] = 35,
                        ["Rank 3"] = 40,
                        ["Rank 4"] = 45,
                        ["Rank 5"] = 50,
                        ["Rank 6"] = 55,
                        ["Rank 7"] = 60,
                },
                ["Fire Nova Totem"] = 4,
                ["Frost Resistance Totem"] = 120,
                ["Magma Totem"] = 20,
                ["Flametongue Totem"] = 120,
                ["Fire Elemental Totem"] = 120,
                ["Totem of Wrath"] = 120,

                ["Healing Stream Totem"] = 60,
                ["Poison Cleansing Totem"] = 120,
                ["Disease Cleansing Totem"] = 120,
                ["Mana Spring Totem"] = 60,
                ["Mana Tide Totem"] = 12,
                ["Fire Resistance Totem"] = 120,

                ["Nature Resistance Totem"] = 120,
                ["Windfury Totem"] = 120,
                ["Windwall Totem"] = 120,
                ["Sentry Totem"] = 300,
                ["Grounding Totem"] = 45,
                ["Grace of Air Totem"] = 120,
                ["Tranquil Air Totem"] = 120,
                ["Wrath of Air Totem"] = 120,
        }

        Shockolate.LoadUI();

        SC_EarthOptsButton:SetText(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["ShowName"]);
        SC_FireOptsButton:SetText(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["ShowName"]);
        SC_WaterOptsButton:SetText(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["ShowName"]);
        SC_AirOptsButton:SetText(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["ShowName"]);
        SC_UtilityOptsButton:SetText(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["ShowName"]);
end;

SlashCommand = function(msg)
        if (msg == "") then
                ShowUIPanel(Shockolate_OptionsUI);
        end;
end;

SetupDropdown_OnLoad = function()
        UIDropDownMenu_Initialize(SC_SetupDropdown, Shockolate.SetupDropdown_Initialize);
        UIDropDownMenu_SetSelectedValue(SC_SetupDropdown, TotemOptions["CurrentSetup"]);
        UIDropDownMenu_SetWidth(150, SC_SetupDropdown);
end;

SetupDropdown_OnClick = function()
        UIDropDownMenu_SetSelectedValue(SC_SetupDropdown, this.value);
end;

SetupDropdown_Initialize = function()
        local selectedValue = UIDropDownMenu_GetSelectedValue(SC_SetupDropdown);
	local info;

        for i=1,getn(TotemOptions["SetupList"]) do
                info = {
                        text = TotemOptions["SetupList"][i];
                        func = Shockolate.SetupDropdown_OnClick;
                }
                UIDropDownMenu_AddButton(info);
        end;
end;

SaveNewSetup = function(newSetupName)
        for i=1,getn(TotemOptions["SetupList"]) do
                if (TotemOptions["SetupList"][i] == newSetupName) then
                        Shockolate.Print("echo", "A Setup by that name already exists. Please use the dropdown.");
                        return;
                end;
        end;
        tinsert(TotemOptions["SetupList"], newSetupName);
        TotemOptions[newSetupName] = TotemOptions[TotemOptions["CurrentSetup"]];
        TotemOptions["CurrentSetup"] = newSetupName;
        local oldDropdown = UIDROPDOWNMENU_INIT_MENU;
        UIDROPDOWNMENU_INIT_MENU = SC_SetupDropdown;
        info = {
                text = newSetupName;
                func = Shockolate.SetupDropdown_OnClick;
        }
        UIDropDownMenu_AddButton(info);
        UIDROPDOWNMENU_INIT_MENU = oldDropdown;
        UIDropDownMenu_SetSelectedValue(SC_SetupDropdown, TotemOptions["CurrentSetup"]);
        SC_SetupNameEdit:ClearFocus();
end;

ChangeSetup = function(id)
        if not id then
                TotemOptions["CurrentSetup"] = UIDropDownMenu_GetSelectedValue(SC_SetupDropdown);
        else
                TotemOptions["CurrentSetup"] = TotemOptions["SetupList"][id];
        end;
end;

DeleteSetup = function(delSetupName)
        if (delSetupName == "Default") then
                return;
        end;
        TotemOptions[delSetupName] = nil;
        for i=getn(TotemOptions["SetupList"]),1,-1 do
                if (TotemOptions["SetupList"][i] == delSetupName) then
                        tremove(TotemOptions["SetupList"],i);
                end;
        end;
        if (TotemOptions["CurrentSetup"] == delSetupName) then
                TotemOptions["CurrentSetup"] = "Default";
                UIDropDownMenu_SetSelectedValue(SC_SetupDropdown, TotemOptions["CurrentSetup"]);
        end;
end;

ChangeRingName = function(ringName, newName)
        TotemOptions[TotemOptions["CurrentSetup"]][ringName.."Ring"]["ShowName"] = newName;
end;

LoadUI = function()
        SC_EarthFrame = CreateFrame("Button", "TotemFrame_EarthMain", UIParent, "SC_FrameTemplate");
        TotemFrame_EarthMain:SetID(10);
        TotemFrame_EarthMain:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Scale"]);
        TotemFrame_EarthMain:SetPoint("CENTER", UIParent, "CENTER", -50, 50);
        TotemFrame_EarthMain:SetAttribute("*type1", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Type"]);
        TotemFrame_EarthMain:SetAttribute("*type2", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Second"]["Type"]);
        TotemFrame_EarthMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Type"].."1", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Spell"]);
        TotemFrame_EarthMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Second"]["Type"].."2", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Second"]["Spell"]);
        TotemFrame_EarthMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Icon"]);
        for i=1,8 do
                SC_EarthTotem = CreateFrame("Button", "TotemFrame_EarthButton"..i, UIParent, "SC_ButtonTemplate");
                SC_EarthTotem:SetID(tonumber("1"..i));
                SC_EarthTotem:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["SmallScale"]);
                SC_EarthTotem:SetPoint("CENTER", "TotemFrame_EarthMain", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Position"]));
                SC_EarthTotem:SetAttribute("*type*", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Type"]);
                SC_EarthTotem:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Type"].."*", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Spell"]);
                getglobal("TotemFrame_EarthButton"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Icon"]);
                if (TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"][tostring(i)]["Shown"] == 0) then
                        SC_EarthTotem:Hide();
                end;
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Shown"] == 0) then
                TotemFrame_EarthMain:Hide();
                for i=1,8 do
                        getglobal("TotemFrame_EarthButton"..i):Hide();
                end;
        end;
        Shockolate.SetRingAlpha("Earth", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Alpha"]);

        SC_FireFrame = CreateFrame("Button", "TotemFrame_FireMain", UIParent, "SC_FrameTemplate");
        TotemFrame_FireMain:SetID(20);
        TotemFrame_FireMain:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Scale"]);
        TotemFrame_FireMain:SetPoint("CENTER", UIParent, "CENTER", 50, 50);
        TotemFrame_FireMain:SetAttribute("*type1", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Type"]);
        TotemFrame_FireMain:SetAttribute("*type2", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Second"]["Type"]);
        TotemFrame_FireMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Type"].."1", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Spell"]);
        TotemFrame_FireMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Second"]["Type"].."2", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Second"]["Spell"]);
        TotemFrame_FireMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Icon"]);
        for i=1,8 do
                SC_FireTotem = CreateFrame("Button", "TotemFrame_FireButton"..i, UIParent, "SC_ButtonTemplate");
                SC_FireTotem:SetID(tonumber("2"..i));
                SC_FireTotem:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["SmallScale"]);
                SC_FireTotem:SetPoint("CENTER", "TotemFrame_FireMain", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Position"]));
                SC_FireTotem:SetAttribute("*type*", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Type"]);
                SC_FireTotem:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Type"].."*", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Spell"]);
                getglobal("TotemFrame_FireButton"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Icon"]);
                if (TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"][tostring(i)]["Shown"] == 0) then
                        SC_FireTotem:Hide();
                end;
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Shown"] == 0) then
                TotemFrame_FireMain:Hide();
                for i=1,8 do
                        getglobal("TotemFrame_FireButton"..i):Hide();
                end;
        end;
        Shockolate.SetRingAlpha("Fire", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Alpha"]);

        SC_WaterFrame = CreateFrame("Button", "TotemFrame_WaterMain", UIParent, "SC_FrameTemplate");
        TotemFrame_WaterMain:SetID(30);
        TotemFrame_WaterMain:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Scale"]);
        TotemFrame_WaterMain:SetPoint("CENTER", UIParent, "CENTER", -50, -50);
        TotemFrame_WaterMain:SetAttribute("*type1", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Type"]);
        TotemFrame_WaterMain:SetAttribute("*type2", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Second"]["Type"]);
        TotemFrame_WaterMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Type"].."1", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Spell"]);
        TotemFrame_WaterMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Second"]["Type"].."2", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Second"]["Spell"]);
        TotemFrame_WaterMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Icon"]);
        for i=1,8 do
                SC_WaterTotem = CreateFrame("Button", "TotemFrame_WaterButton"..i, UIParent, "SC_ButtonTemplate");
                SC_WaterTotem:SetID(tonumber("3"..i));
                SC_WaterTotem:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["SmallScale"]);
                SC_WaterTotem:SetPoint("CENTER", "TotemFrame_WaterMain", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Position"]));
                SC_WaterTotem:SetAttribute("*type*", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Type"]);
                SC_WaterTotem:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Type"].."*", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Spell"]);
                getglobal("TotemFrame_WaterButton"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Icon"]);
                if (TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"][tostring(i)]["Shown"] == 0) then
                        SC_WaterTotem:Hide();
                end;
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Shown"] == 0) then
                TotemFrame_WaterMain:Hide();
                for i=1,8 do
                        getglobal("TotemFrame_WaterButton"..i):Hide();
                end;
        end;
        Shockolate.SetRingAlpha("Water", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Alpha"]);

        SC_AirFrame = CreateFrame("Button", "TotemFrame_AirMain", UIParent, "SC_FrameTemplate");
        TotemFrame_AirMain:SetID(40);
        TotemFrame_AirMain:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Scale"]);
        TotemFrame_AirMain:SetPoint("CENTER", UIParent, "CENTER", 50, -50);
        TotemFrame_AirMain:SetAttribute("*type1", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Type"]);
        TotemFrame_AirMain:SetAttribute("*type2", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Second"]["Type"]);
        TotemFrame_AirMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Type"].."1", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Spell"]);
        TotemFrame_AirMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Second"]["Type"].."2", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Second"]["Spell"]);
        TotemFrame_AirMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Icon"]);
        for i=1,8 do
                SC_AirTotem = CreateFrame("Button", "TotemFrame_AirButton"..i, UIParent, "SC_ButtonTemplate");
                SC_AirTotem:SetID(tonumber("4"..i));
                SC_AirTotem:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["SmallScale"]);
                SC_AirTotem:SetPoint("CENTER", "TotemFrame_AirMain", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Position"]));
                SC_AirTotem:SetAttribute("*type*", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Type"]);
                SC_AirTotem:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Type"].."*", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Spell"]);
                getglobal("TotemFrame_AirButton"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Icon"]);
                if (TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"][tostring(i)]["Shown"] == 0) then
                        SC_AirTotem:Hide();
                end;
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Shown"] == 0) then
                TotemFrame_AirMain:Hide();
                for i=1,8 do
                        getglobal("TotemFrame_AirButton"..i):Hide();
                end;
        end;
        Shockolate.SetRingAlpha("Air", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Alpha"]);

        SC_UtilityFrame = CreateFrame("Button", "TotemFrame_UtilityMain", UIParent, "SC_FrameTemplate");
        TotemFrame_UtilityMain:SetID(50);
        TotemFrame_UtilityMain:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Scale"]);
        TotemFrame_UtilityMain:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
        TotemFrame_UtilityMain:SetAttribute("*type1", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Type"]);
        TotemFrame_UtilityMain:SetAttribute("*type2", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Second"]["Type"]);
        TotemFrame_UtilityMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Type"].."1", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Spell"]);
        TotemFrame_UtilityMain:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Second"]["Type"].."2", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Second"]["Spell"]);
        TotemFrame_UtilityMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Icon"]);
        for i=1,8 do
                SC_UtilityTotem = CreateFrame("Button", "TotemFrame_UtilityButton"..i, UIParent, "SC_ButtonTemplate");
                SC_UtilityTotem:SetID(tonumber("5"..i));
                SC_UtilityTotem:SetScale(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["SmallScale"]);
                SC_UtilityTotem:SetPoint("CENTER", "TotemFrame_UtilityMain", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Position"]));
                SC_UtilityTotem:SetAttribute("*type*", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Type"]);
                SC_UtilityTotem:SetAttribute("*"..TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Type"].."*", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Spell"]);
                getglobal("TotemFrame_UtilityButton"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Icon"]);
                if (TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"][tostring(i)]["Shown"] == 0) then
                        SC_UtilityTotem:Hide();
                end;
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Shown"] == 0) then
                TotemFrame_UtilityMain:Hide();
                for i=1,8 do
                        getglobal("TotemFrame_UtilityButton"..i):Hide();
                end;
        end;
        Shockolate.SetRingAlpha("Utility", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Alpha"]);

        Shockolate.SelfRezTime();
end;

LoadKeybinds = function()
        if (TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Main"]["Keybind"], "TotemFrame_EarthMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Main"]["Keybind"], "TotemFrame_FireMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Main"]["Keybind"], "TotemFrame_WaterMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Main"]["Keybind"], "TotemFrame_AirMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Main"]["Keybind"], "TotemFrame_UtilityMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Second"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Second"]["Keybind"], "TotemFrame_EarthMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Second"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Second"]["Keybind"], "TotemFrame_FireMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Second"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Second"]["Keybind"], "TotemFrame_WaterMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Second"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Second"]["Keybind"], "TotemFrame_AirMain", "LeftButton");
        end;
        if (TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Second"]["Keybind"]) then
                SetBindingClick(TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Second"]["Keybind"], "TotemFrame_UtilityMain", "LeftButton");
        end;
end;

GetSpellNameText = function(id)
        spellType, spellSlot = GetCursorInfo();
        idNum = tonumber(strsub(id, 2));
        if (tonumber(strsub(id, 1, 1)) == 1) then
                idType = "Earth";
        elseif (tonumber(strsub(id, 1, 1)) == 2) then
                idType = "Fire";
        elseif (tonumber(strsub(id, 1, 1)) == 3) then
                idType = "Water";
        elseif (tonumber(strsub(id, 1, 1)) == 4) then
                idType = "Air";
        elseif (tonumber(strsub(id, 1, 1)) == 5) then
                idType = "Utility";
        end;
        if (spellType == "macro") then
                spellName, texture = GetMacroInfo(spellSlot);
                TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Type"] = "macro";
                TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Spell"] = spellSlot;
                TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Icon"] = texture;
                getglobal("TotemFrame_"..idType.."Button"..idNum):SetAttribute("*type*", "macro");
                getglobal("TotemFrame_"..idType.."Button"..idNum):SetAttribute("*macro*", spellSlot);
                getglobal("TotemFrame_"..idType.."Button"..idNum.."Icon"):SetTexture(texture);
        elseif (spellType == "spell") then
                spellName, spellRank = GetSpellName(spellSlot, BOOKTYPE_SPELL);
                texture = GetSpellTexture(spellName);
--                Shockolate.Print("echo", "ID: "..id.." - Name: "..spellName.." - Texture: "..texture);
                TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Type"] = "spell";
                TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Icon"] = texture;
                if IsShiftKeyDown() then
                        TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Spell"] = spellName.."("..spellRank..")";
                        getglobal("TotemFrame_"..idType.."Button"..idNum):SetAttribute("*spell*", spellName.."("..spellRank..")");
                else
                        TotemOptions[TotemOptions["CurrentSetup"]][idType.."Ring"][tostring(idNum)]["Spell"] = spellName;
                        getglobal("TotemFrame_"..idType.."Button"..idNum):SetAttribute("*spell*", spellName);
                end;
                getglobal("TotemFrame_"..idType.."Button"..idNum):SetAttribute("*type*", "spell");
                getglobal("TotemFrame_"..idType.."Button"..idNum.."Icon"):SetTexture(texture);
        end;
        ClearCursor();
end;

UpdateButton = function(id)
        id = tostring(id);
        if (id == "0") then
                id = "Main";
        elseif (id == "10") then
                id = "Second";
        end;
        spellType, spellSlot = GetCursorInfo();
        if (spellType == "macro") then
                spellName, texture = GetMacroInfo(spellSlot);
                TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Type"] = "macro";
                TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"] = spellSlot;
                TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Icon"] = texture;
                if (id == "Main") then
                        getglobal("TotemFrame_"..SC_OptionRing.."MainIcon"):SetTexture(texture);
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*type1", "macro");
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell1", spellSlot);
                elseif (id == "Second") then
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*type2", "macro");
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell2", spellSlot);
                else
                        getglobal("TotemFrame_"..SC_OptionRing.."Button"..id):SetAttribute("*type*", "macro");
                        getglobal("TotemFrame_"..SC_OptionRing.."Button"..id):SetAttribute("*spell*", spellSlot);
                        getglobal("TotemFrame_"..SC_OptionRing.."Button"..id.."Icon"):SetTexture(texture);
                end;
                getglobal("SC_RingTotem"..id.."Icon"):SetTexture(texture);
        elseif (spellType == "spell") then
                spellName, spellRank = GetSpellName(spellSlot, BOOKTYPE_SPELL);
                texture = GetSpellTexture(spellName);
--                Shockolate.Print("echo", "ID: "..id..SC_OptionRing.." - Name: "..spellName.." - Texture: "..texture);
                TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Type"] = "spell";
                if IsShiftKeyDown() then
                        TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"] = spellName.."("..spellRank..")";
                else
                        TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"] = spellName;
                end;
                TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Icon"] = texture;
                if (id == "Main") then
                        getglobal("TotemFrame_"..SC_OptionRing.."MainIcon"):SetTexture(texture);
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*type1", "spell");
                        if IsShiftKeyDown() then
                                getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell1", spellName.."("..spellRank..")");
                        else
                                getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell1", spellName);
                        end;
                elseif (id == "Second") then
                        getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*type2", "spell");
                        if IsShiftKeyDown() then
                                getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell2", spellName.."("..spellRank..")");
                        else
                                getglobal("TotemFrame_"..SC_OptionRing.."Main"):SetAttribute("*spell2", spellName);
                        end;
                else
                        getglobal("TotemFrame_"..SC_OptionRing.."Button"..id):SetAttribute("*type*", "spell");
                        if IsShiftKeyDown() then
                                getglobal("TotemFrame_"..SC_OptionRing.."Button"..id):SetAttribute("*spell*", spellName.."("..spellRank..")");
                        else
                                getglobal("TotemFrame_"..SC_OptionRing.."Button"..id):SetAttribute("*spell*", spellName);
                        end;
                        getglobal("TotemFrame_"..SC_OptionRing.."Button"..id.."Icon"):SetTexture(texture);
                end;
                getglobal("SC_RingTotem"..id.."Icon"):SetTexture(texture);
        end;
        ClearCursor();
end;

DragSpellAway = function(id, ringType)
        if not IsShiftKeyDown() then
                return;
        end;
        if InCombatLockdown() then
                return;
        end;
        if not ringType then
                typeID = strsub(id, 1, 1);
                id = strsub(id, 2);
                if (typeID == "1") then
                        ringType = "Earth";
                elseif (typeID == "2") then
                        ringType = "Fire";
                elseif (typeID == "3") then
                        ringType = "Water";
                elseif (typeID == "4") then
                        ringType = "Air";
                elseif (typeID == "5") then
                        ringType = "Utility";
                end;
        else
                id = tostring(id);
                if (id == "0") then
                        id = "Main";
                elseif (id == "10") then
                        id = "Second";
                end;
        end;
        i = 1;
        spellID = nil;
        doClear = nil;
        SC_spellType = TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Type"];
        SC_spellName = TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Spell"];
        if (SC_spellType == "spell") then
                if strfind(SC_spellName, "(Rank ") then
                        while true do
                                spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                                if not spellName then
                                        do break end;
                                end;
                                spellName = spellName.."("..spellRank..")";
                                if (spellName == SC_spellName) then
                                        spellID = i;
                                end;
                                i = i + 1;
                        end;
                        if spellID then
                                PickupSpell(spellID, BOOKTYPE_SPELL);
                                doClear = 1;
                        end;
                else
                        while true do
                                spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                                if not spellName then
                                        do break end;
                                end;
                                if (spellName == SC_spellName) then
                                        spellID = i;
                                end;
                                i = i + 1;
                        end;
                        if spellID then
                                PickupSpell(spellID, BOOKTYPE_SPELL);
                                doClear = 1;
                        end;
                end;
        elseif (SC_spellType == "macro") then
                PickupMacro(SC_spellName);
                doClear = 1;
        end;
        if doClear then
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Type"] = "spell";
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Spell"] = "";
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Icon"] = "";
                getglobal("TotemFrame_"..ringType.."Button"..id):SetAttribute("*type*", "spell");
                getglobal("TotemFrame_"..ringType.."Button"..id):SetAttribute("*spell*", "");
                getglobal("TotemFrame_"..ringType.."Button"..id.."Icon"):SetTexture("");
                if (Shockolate_OptionsUI:IsShown() and (ringType == SC_OptionRing)) then
                        getglobal("SC_RingTotem"..id.."Icon"):SetTexture("");
                end;
        end;
end;

TotemTooltip = function(id)
        i = 1;
        spellID = nil;
        SC_spellRank = nil;
        typeID = strsub(id, 1, 1);
        id = strsub(id, 2);
        if (typeID == "1") then
                ringType = "Earth";
                scr,scg,scb = .78,.61,.43;
        elseif (typeID == "2") then
                ringType = "Fire";
                scr,scg,scb = 1,0,0;
        elseif (typeID == "3") then
                ringType = "Water";
                scr,scg,scb = 0,1,1;
        elseif (typeID == "4") then
                ringType = "Air";
                scr,scg,scb = .75,.75,1;
        elseif (typeID == "5") then
                ringType = "Utility";
                scr,scg,scb = .96,.55,.73;
        end;
        if (id == "0") then
                GameTooltip:AddLine(TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["ShowName"], scr,scg,scb);
                GameTooltip:AddDoubleLine("Left Click:", TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Main"]["Spell"], scr,scg,scb, 1,1,1);
                GameTooltip:AddDoubleLine("Right Click:", TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Second"]["Spell"], scr,scg,scb, 1,1,1);
                if TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Main"]["Keybind"] then
                        GameTooltip:AddDoubleLine("Left Keybind:", TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Main"]["Keybind"], 1,1,1, 1,1,1);
                end;
                if TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Second"]["Keybind"] then
                        GameTooltip:AddDoubleLine("Right Keybind:", TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Second"]["Keybind"], 1,1,1, 1,1,1);
                end;
        else
                SC_spellName = TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Spell"];
                if strfind(SC_spellName, "Rank ") then
                        while true do
                                spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                                if not spellName then
                                        do break end;
                                end;
                                spellName = spellName.."("..spellRank..")";
                                if (spellName == SC_spellName) then
                                        spellID = i;
                                        SC_spellRank = spellRank;
                                end;
                                i = i + 1;
                        end;
                else
                        while true do
                                spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                                if not spellName then
                                        do break end;
                                end;
                                if (spellName == SC_spellName) then
                                        spellID = i;
                                        SC_spellRank = spellRank;
                                end;
                                i = i + 1;
                        end;
                end;
                if spellID then
                        GameTooltip:SetSpell(spellID, BOOKTYPE_SPELL);
                        GameTooltipTextRight1:SetText("|cffacacac"..SC_spellRank.."|r");
                        GameTooltipTextRight1:Show();
                end;
        end;
        GameTooltip:Show();
end;

TotemCast = function()
        if not strfind(arg2, "Totem") then
                return;
        end;
        if (arg2 == "Earthbind Totem") or (arg2 == "Strength of Earth Totem") or (arg2 == "Stoneskin Totem") or (arg2 == "Stoneclaw Totem") or (arg2 == "Tremor Totem") or (arg2 == "Earth Elemental Totem") then
                TotemDuration["Earth"] = TotemTimes[arg2];
        elseif (arg2 == "Searing Totem") then
                TotemDuration["Fire"] = TotemTimes[arg2][arg3];
        elseif (arg2 == "Fire Nova Totem") then
                talName, icon, tier, column, currentRank, maxRank = GetTalentInfo(1,9);
                if (talName == "Improved Fire Totems") then
                        reduceTime = tonumber(currentRank) / tonumber(maxRank) * 2;
--                        Shockolate.Print("echo", "Found Talent: "..currentRank.." / "..maxRank.." ("..reduceTime.." sec reduction).");
                        TotemDuration["Fire"] = TotemTimes[arg2] - reduceTime;
                else
--                        Shockolate.Print("echo", "Imp Fire Totems Talent Not Found ("..talName.."). Assuming no talent points.");
                        TotemDuration["Fire"] = TotemTimes[arg2];
                end;
        elseif (arg2 == "Frost Resistance Totem") or (arg2 == "Magma Totem") or (arg2 == "Flametongue Totem") or (arg2 == "Totem of Wrath") then
                TotemDuration["Fire"] = TotemTimes[arg2];
        elseif (arg2 == "Healing Stream Totem") or (arg2 == "Poison Cleansing Totem") or (arg2 == "Disease Cleansing Totem") or (arg2 == "Mana Spring Totem") or (arg2 == "Mana Tide Totem") or (arg2 == "Fire Resistance Totem") then
                TotemDuration["Water"] = TotemTimes[arg2];
        elseif (arg2 == "Nature Resistance Totem") or (arg2 == "Grounding Totem") or (arg2 == "Windfury Totem") or (arg2 == "Windwall Totem") or (arg2 == "Sentry Totem") or (arg2 == "Grace of Air Totem") or (arg2 == "Tranquil Air Totem") or (arg2 == "Wrath of Air Totem") then
                TotemDuration["Air"] = TotemTimes[arg2];
        elseif (arg2 == "Totemic Call") then
                TotemDuration["Earth"] = 0;
                TotemDuration["Fire"] = 0;
                TotemDuration["Water"] = 0;
                TotemDuration["Air"] = 0;
        else
                Shockolate.Print("echo", "Unknown Totem Cast: "..arg2.."("..arg3..")");
        end;
end;

TimerTick = function(elapsed)
        if (UnitClass("player") ~= "Shaman") then
                return;
        end;
        if TotemDuration["Earth"] then
                if (TotemDuration["Earth"] > 0) then
                        if (TotemDuration["Earth"] < 8) then
                                UIFrameFlash(TotemFrame_EarthMain, 2, 2, 8, true, 1, 1);
                        end;
                        TotemDuration["Earth"] = TotemDuration["Earth"] - elapsed;
                        TotemFrame_EarthMainTitle:SetText(ceil(TotemDuration["Earth"]));
                else
                        TotemDuration["Earth"] = nil;
                        TotemFrame_EarthMainTitle:SetText("");
                end;
        end;
        if TotemDuration["Fire"] then
                if (TotemDuration["Fire"] > 0) then
                        if (TotemDuration["Fire"] < 8) then
                                UIFrameFlash(TotemFrame_FireMain, 2, 2, 8, true, 1, 1);
                        end;
                        TotemDuration["Fire"] = TotemDuration["Fire"] - elapsed;
                        TotemFrame_FireMainTitle:SetText(ceil(TotemDuration["Fire"]));
                else
                        TotemDuration["Fire"] = nil;
                        TotemFrame_FireMainTitle:SetText("");
                end;
        end;
        if TotemDuration["Water"] then
                if (TotemDuration["Water"] > 0) then
                        if (TotemDuration["Water"] < 8) then
                                UIFrameFlash(TotemFrame_WaterMain, 2, 2, 8, true, 1, 1);
                        end;
                        TotemDuration["Water"] = TotemDuration["Water"] - elapsed;
                        TotemFrame_WaterMainTitle:SetText(ceil(TotemDuration["Water"]));
                else
                        TotemDuration["Water"] = nil;
                        TotemFrame_WaterMainTitle:SetText("");
                end;
        end;
        if TotemDuration["Air"] then
                if (TotemDuration["Air"] > 0) then
                        if (TotemDuration["Air"] < 8) then
                                UIFrameFlash(TotemFrame_AirMain, 2, 2, 8, true, 1, 1);
                        end;
                        TotemDuration["Air"] = TotemDuration["Air"] - elapsed;
                        TotemFrame_AirMainTitle:SetText(ceil(TotemDuration["Air"]));
                else
                        TotemDuration["Air"] = nil;
                        TotemFrame_AirMainTitle:SetText("");
                end;
        end;
        if TotemDuration["Utility"] then
                if (TotemDuration["Utility"] > 0) then
                        TotemDuration["Utility"] = TotemDuration["Utility"] - elapsed;
                        if (TotemDuration["Utility"] > 60) then
                                TotemFrame_UtilityMainTitle:SetText(ceil(TotemDuration["Utility"] / 60).."m");
                        else
                                TotemFrame_UtilityMainTitle:SetText(ceil(TotemDuration["Utility"]).."s");
                        end;
                else
                        TotemDuration["Utility"] = nil;
                        TotemFrame_UtilityMainTitle:SetText("");
                end;
        end;
end;

ChangeOptions = function(id)
        if (id == "1") then
                SC_OptionRing = "Earth";
        elseif (id == "2") then
                SC_OptionRing = "Fire";
        elseif (id == "3") then
                SC_OptionRing = "Water";
        elseif (id == "4") then
                SC_OptionRing = "Air";
        elseif (id == "5") then
                SC_OptionRing = "Utility";
        end;
        SC_DoBinding = nil;
        mainBindText = "";
        secondBindText = "";
        SC_StatusText:SetText("Totem Options - "..SC_OptionRing.." Ring");
        SC_RingScale:SetValue(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Scale"]);
        SC_RingSmallScale:SetValue(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["SmallScale"]);
        SC_RingRadius:SetValue(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Radius"]);
        SC_RingAlpha:SetValue(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Alpha"]);
        SC_RingCombatAlpha:SetValue(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["CombatAlpha"]);
        SC_RingShow:SetChecked(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Shown"]);
        SC_RingTotemMainIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Main"]["Icon"]);
        SC_RingTotemSecondIcon:SetTexture(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Second"]["Icon"]);
        SC_mainBind = TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Main"]["Keybind"];
        if not SC_mainBind then
                SC_mainBind = "";
        end;
        if strfind(SC_mainBind, "-") then
                while strfind(SC_mainBind, "-") do
                        index = strfind(SC_mainBind, "-");
                        mainBindText = mainBindText..strsub(SC_mainBind,1,1);
                        SC_mainBind = strsub(SC_mainBind, index+1);
                end;
                mainBindText = mainBindText.."-"..SC_mainBind;
        else
                mainBindText = SC_mainBind;
        end;
        SC_BindMainButton:SetText(mainBindText);
        SC_secondBind = TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Second"]["Keybind"];
        if not SC_secondBind then
                SC_secondBind = "";
        end;
        if strfind(SC_secondBind, "-") then
                while strfind(SC_secondBind, "-") do
                        index = strfind(SC_secondBind, "-");
                        secondBindText = secondBindText..strsub(SC_secondBind,1,1);
                        SC_secondBind = strsub(SC_secondBind, index+1);
                end;
                secondBindText = secondBindText.."-"..SC_secondBind;
        else
                secondBindText = SC_secondBind;
        end;
        SC_BindSecondButton:SetText(secondBindText);
        
        for i=1,8 do
                getglobal("SC_RingTotem"..i.."Icon"):SetTexture(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][tostring(i)]["Icon"]);
                getglobal("SC_Totem"..i.."Show"):SetChecked(TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][tostring(i)]["Shown"]);
        end;
end;

KeyBindAssign = function()
        local screenshotKey = GetBindingKey("SCREENSHOT");
        if ( screenshotKey and arg1 == screenshotKey ) then
                Screenshot();
                Shockolate.ChangeBindType(SC_DoBinding);
                return;
        end;
        local replyKey = GetBindingKey("REPLY");
        if ( replyKey and arg1 == replyKey ) then
                ChatFrame_OpenChat("/r");
                Shockolate.ChangeBindType(SC_DoBinding);
                return;
        end;
        SC_BindButton = arg1;
        if (SC_BindButton == "ESCAPE") then
                HideUIPanel(Shockolate_OptionsUI);
                Shockolate.ChangeBindType(SC_DoBinding);
        elseif (SC_BindButton == "ENTER") then
                ChatFrame_OpenChat("");
                Shockolate.ChangeBindType(SC_DoBinding);
        elseif (SC_BindButton == "/") then
                ChatFrame_OpenChat("/");
                Shockolate.ChangeBindType(SC_DoBinding);
        elseif (SC_BindButton == "UNKNOWN") or (SC_BindButton == "SHIFT") or (SC_BindButton == "CTRL") or (SC_BindButton == "ALT") then
                return;
        else
                if (SC_DoBinding == nil) or (SC_OptionRing == nil) then
                        return;
                end;
                buttonText = "-"..SC_BindButton;
                if IsShiftKeyDown() then
                        SC_BindButton = "SHIFT-"..SC_BindButton;
                        buttonText = "S"..buttonText;
                end;
                if IsControlKeyDown() then
                        SC_BindButton = "CTRL-"..SC_BindButton;
                        buttonText = "C"..buttonText;
                end;
                if IsAltKeyDown() then
                        SC_BindButton = "ALT-"..SC_BindButton;
                        buttonText = "A"..buttonText;
                end;
                if (buttonText == "-"..SC_BindButton) then
                        buttonText = SC_BindButton;
                end;
                local oldAction = GetBindingAction(SC_BindButton);
                if (oldAction ~= "") then
                        local oldActionTitle = GetBindingText(oldAction, "BINDING_NAME_");
                        Shockolate.Print("echo", "Old Action Unbound: "..oldActionTitle);
--                        return;
                end;
                buttonBind = "TotemFrame_"..SC_OptionRing.."Main";
                if (SC_DoBinding == "Main") then
                        TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Main"]["Keybind"] = SC_BindButton;
                        SetBindingClick(SC_BindButton, buttonBind, "LeftButton");
                        SC_BindMainButton:SetText(buttonText);
                else
                        TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"]["Second"]["Keybind"] = SC_BindButton;
                        SetBindingClick(SC_BindButton, buttonBind, "RightButton");
                        SC_BindSecondButton:SetText(buttonText);
                end;
                Shockolate.ChangeBindType(SC_DoBinding);
        end;
end;

ChangeBindType = function(id)
        SC_BindMainButton:UnlockHighlight();
        SC_BindSecondButton:UnlockHighlight();
        SC_SetupNameEdit:ClearFocus();
        if (SC_DoBinding == id) then
                SC_DoBinding = nil;
        else
                SC_DoBinding = id;
                getglobal("SC_Bind"..id.."Button"):LockHighlight();
        end;
end;

OptionTooltip = function(id)
        id = tostring(id);
        if (id == "0") then
                id = "Main";
        elseif (id == "10") then
                id = "Second";
        end;
        i = 1;
        spellID = nil;
        SC_spellRank = nil;
--        Shockolate.Print("echo", "ID: "..id.." Opt: "..SC_OptionRing);
        SC_spellName = TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"];
        if strfind(SC_spellName, "Rank ") then
                while true do
                        spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                        if not spellName then
                                do break end;
                        end;
                        spellName = spellName.."("..spellRank..")";
                        if (spellName == SC_spellName) then
                                spellID = i;
                                SC_spellRank = spellRank;
                        end;
                        i = i + 1;
                end;
        else
                while true do
                        spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                        if not spellName then
                                do break end;
                        end;
                        if (spellName == SC_spellName) then
                                spellID = i;
                                SC_spellRank = spellRank;
                        end;
                        i = i + 1;
                end;
        end;
        if spellID then
                GameTooltip:SetSpell(spellID, BOOKTYPE_SPELL);
                GameTooltipTextRight1:SetText("|cffacacac"..SC_spellRank.."|r");
                GameTooltipTextRight1:Show();
        end;
        GameTooltip:Show();
end;

HotkeyTooltip = function(id)
        if (id == "Main") then
                GameTooltip:AddDoubleLine("Left Click:", TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"], 1,1,1, 1,1,1);
                GameTooltip:AddDoubleLine("Hotkey:", TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Keybind"], 1,1,1, 1,1,1);
        else
                GameTooltip:AddDoubleLine("Right Click:", TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Spell"], 1,1,1, 1,1,1);
                GameTooltip:AddDoubleLine("Hotkey:", TotemOptions[TotemOptions["CurrentSetup"]][SC_OptionRing.."Ring"][id]["Keybind"], 1,1,1, 1,1,1);
        end;
        GameTooltip:Show();
end;

SetRingAlpha = function(ringType, alphaValue)
        getglobal("TotemFrame_"..ringType.."Main"):SetAlpha(alphaValue);
        for i=1,8 do
                getglobal("TotemFrame_"..ringType.."Button"..i):SetAlpha(alphaValue);
        end;
end;

SetSinglePosition = function(id, ringType, newPos)
        TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][tostring(id)]["Position"] = newPos;
        getglobal("TotemFrame_"..ringType.."Button"..id):ClearAllPoints();
        getglobal("TotemFrame_"..ringType.."Button"..id):SetPoint("CENTER", "TotemFrame_"..ringType.."Main", "CENTER", TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Radius"] * cos(TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][tostring(id)]["Position"]), TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Radius"] * sin(TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][tostring(id)]["Position"]));
end;

SetRingScale = function(ringType, newScale)
        TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Scale"] = newScale;
        getglobal("TotemFrame_"..ringType.."Main"):SetScale(TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Scale"]);
        for i=1,8 do
                getglobal("TotemFrame_"..ringType.."Button"..i):SetScale(TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Scale"] * TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["SmallScale"]);
        end;
end;

ResetRingPosition = function(ringName)
        thisRing = getglobal("TotemFrame_"..ringName.."Main");
        thisRing:ClearAllPoints();
        thisRing:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
end;

ShowToggle = function(ringType, showValue)
        if (showValue == true or showValue == 1 ) then
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Shown"] = true;
                getglobal("TotemFrame_"..ringType.."Main"):Show();
                for i=1,8 do
                        getglobal("TotemFrame_"..ringType.."Button"..i):Show();
                end;
        else
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"]["Shown"] = 0;
                getglobal("TotemFrame_"..ringType.."Main"):Hide();
                for i=1,8 do
                        getglobal("TotemFrame_"..ringType.."Button"..i):Hide();
                end;
        end;
end;

ShowIndivToggle = function(id, ringType, showValue)
        id = tostring(id);
        Shockolate.Print("echo", showValue);
        if (showValue == true or showValue == 1 ) then
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Shown"] = true;
                getglobal("TotemFrame_"..ringType.."Button"..id):Show();
        else
                TotemOptions[TotemOptions["CurrentSetup"]][ringType.."Ring"][id]["Shown"] = 0;
                getglobal("TotemFrame_"..ringType.."Button"..id):Hide();
        end;
end;

SetTextColor = function(r, g, b)
        TotemOptions[TotemOptions["CurrentSetup"]]["TextOptions"]["r"] = r;
        TotemOptions[TotemOptions["CurrentSetup"]]["TextOptions"]["g"] = g;
        TotemOptions[TotemOptions["CurrentSetup"]]["TextOptions"]["b"] = b;
        TotemFrame_EarthMainTitle:SetTextColor(r,g,b);
        TotemFrame_FireMainTitle:SetTextColor(r,g,b);
        TotemFrame_WaterMainTitle:SetTextColor(r,g,b);
        TotemFrame_AirMainTitle:SetTextColor(r,g,b);
        TotemFrame_UtilityMainTitle:SetTextColor(r,g,b);
end;

SelfRezTime = function()
        i = 1;
        spellID = nil;
        while true do
                spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
                if not spellName then
                        do break end;
                end;
                if (spellName == "Reincarnation") then
                        spellID = i;
                end;
                i = i + 1;
        end;
        if spellID then
                start, duration = GetSpellCooldown(spellID, BOOKTYPE_SPELL);
                if (start > 0 and duration > 0) then
                        remainTime = duration - (GetTime() - start);
                        TotemDuration["Utility"] = remainTime;
                end;
        end;
end;

CombatEnable = function(event)
        if (event == "PLAYER_REGEN_DISABLED") then
                Shockolate.SetRingAlpha("Earth", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["CombatAlpha"]);
                Shockolate.SetRingAlpha("Fire", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["CombatAlpha"]);
                Shockolate.SetRingAlpha("Water", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["CombatAlpha"]);
                Shockolate.SetRingAlpha("Air", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["CombatAlpha"]);
                Shockolate.SetRingAlpha("Utility", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["CombatAlpha"]);
                if SC_ApplyCombatChange then
                        Shockolate.ApplyChanges();
                end;
        else
                Shockolate.SetRingAlpha("Earth", TotemOptions[TotemOptions["CurrentSetup"]]["EarthRing"]["Alpha"]);
                Shockolate.SetRingAlpha("Fire", TotemOptions[TotemOptions["CurrentSetup"]]["FireRing"]["Alpha"]);
                Shockolate.SetRingAlpha("Water", TotemOptions[TotemOptions["CurrentSetup"]]["WaterRing"]["Alpha"]);
                Shockolate.SetRingAlpha("Air", TotemOptions[TotemOptions["CurrentSetup"]]["AirRing"]["Alpha"]);
                Shockolate.SetRingAlpha("Utility", TotemOptions[TotemOptions["CurrentSetup"]]["UtilityRing"]["Alpha"]);
        end;
end;

ApplyChanges = function()
        SC_ApplyCombatChange = nil;
end;

ChatEvent = function()
end;

---------------------------------------------------------------------
-- UI Related Functions
---------------------------------------------------------------------

--chat print functions, allows PARTY, GUILD, RAID, ECHO, OFFICER, TELLS
Print = function(type, str)
        if not (str) then
                Shockolate.Print("echo", "No Message to Print");
        else
                if (type == "echo") then
                        if DEFAULT_CHAT_FRAME then
                                str = "|cffff0000Shockolate>|r "..str;
                                DEFAULT_CHAT_FRAME:AddMessage(str);
                        end;
                else
                        if ((type == "party") or (type == "guild") or (type == "raid") or (type == "officer") or (type == "say")) then
                                type = strupper(type);
                                SendChatMessage(str, type);
                        elseif (strsub(type, 1, 2) == "/t") then
                                SendChatMessage(str, "WHISPER", nil, strsub(type, 4));
                        elseif (strsub(type, 1, 2) == "/c") then
                                SendChatMessage(str, "CHANNEL", nil, GetChannelName(strsub(type, 4)));
                        elseif (type == "hidparty") then
                                SendAddonMessage("Totem", str, "PARTY");
                        elseif (type == "hidraid") then
                                SendAddonMessage("Totem", str, "RAID");
                        elseif (type == "hidguild") then
                                SendAddonMessage("Totem", str, "GUILD");
                        else
                                Shockolate.Print("echo", "Invalid Send Type");
                        end;
                end;
        end;
end;

}
